/**********************************************************
*                                                         *
* (c) 2008 - 2018 LnK                                     *
*                                                         *
* LnKSLIMbusBridge_IF.h									  *
* Version 1.11                                            *
*                                                         *
* Header file for LnKSLIMbusBridge_IF DLL                 *
*                                                         *
* Date 17 Sept 2018                                       *
*                                                         *
* Johan Klewais                                           *
*                                                         *
* www.lnk-tools.com - info@lnk-tools.com                  *
*                                                         *
**********************************************************/


extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusOpen(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusClose(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetSWVersion(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetDLLVersion(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRequestModel(char * ModelType, char * FirmwareVersion, char * IPVersion);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeLoadProjectFile(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRequestScriptLibraryContent( char * FileList);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgePlayScript(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRequestPortConfiguration(char * portstatus, int * ipr, int * iprmis, int * opr, int * oprmis );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRequestBridgeConfiguration(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeLoadScriptLibrary(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeLoadScript(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgePlayBuffer(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRequestBusStatus(int * ClockGear, int * RootFrequency, int * SubFrameMode, int * Status );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgePlayMessage(int MsgType, int MsgCode, char *  SrcAddr, char *  DstAddr, char * Params );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgePlayScriptFromLibrary(int  ScriptID  );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeFramerControl( int ctrl );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeManagerControl( int ctrl );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeSnifferControl( int ctrl );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReset( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusGetReply( char * reply, int len );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeImportRegister(char * filename, int logicaladdress, int slicesize );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeExportRegister(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeExportLiveView(char * filename, unsigned long startindex );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeLiveViewCount(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeWriteRegister(int logicaladdress, int regaddress, char * datastring );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReadRegister(int logicaladdress, int regaddress, int slicesize , char * datastring );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeSetPollTiming(int  DLLPollTimeMs, int AudioBridgePollTimeMs );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeLoadScriptAutomator(char * filename );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeUseLiterals(int enable );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeClearLiveView(void );

// debug features
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusDebugMakeReply( char * buf );


// Model 12P features
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReportFramerConfig( int * FramerBootFrequency, int * FramerBootSM, int * FramerBootCG, int * FramerBootMode, int * ComponentAddress );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReportPhyConfig( int * SLIMbusLevel, int * BusHoldEnabled, int * SD1Assign );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReportClkConfig( int * ExtClkLevel, int * ExtClkDir, int * ExtClkZin , int * ExtClkSrc , int * ExtClkDiv , int * FramerPllRef, int * AudioPllRef );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReportDigAudioConfig( int * SpdifAsrcMode, int * OpticalAsrcMode, int * DsiOutAsrcMode , int * DsiOutAsrcClrRef , int * DsiLevel , int * DsiInFormat, int * DsiInDL , int * DsiInClkMode , int * DsiOutFormat , int * DsiOutDL, int * DsiOutClkMode );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReportDataPathConfig( int * Sdin12Sel, int * Sdin34Sel, int * Dsi8ChInEna , int * Sdin56Sel , int * Sdout1Sel , int * Dsi8ChOutEna, int * Sdout2Sel , int * LoopBackMode );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeReportPresenceRate( int * PresenceRate[] );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeIPReset(void);
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeExtClockConfig( unsigned long Level, unsigned long SMAFunction, unsigned long Impedance, unsigned long OutputSource, unsigned long DivisionFactor, unsigned long FramerPLLRef, unsigned long AudioPLLRef, unsigned long Frequency );




extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeDisconnectHardware( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeConnectHardware( unsigned long idx );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRefreshHardwareList( void );
extern "C" __declspec(dllexport) int _stdcall LnKSLIMbusBridgeRequestHardwareList( char * plist );






// Return values defines

#define	LNK_SLIMBUS_BRIDGE_OK						0
#define LNK_SLIMBUS_BRIDGE_INCOMPATIBLE_VERSION		(-1)
#define LNK_SLIMBUS_BRIDGE_WRONG_DATA_FORMAT		(-2)
#define LNK_SLIMBUS_BRIDGE_NOT_FOUND				(-3)
#define LNK_SLIMBUS_BRIDGE_FILE_ACCESS_ERROR		(-4)
#define LNK_SLIMBUS_BRIDGE_ACTION_NOT_ALLOWED		(-5)
#define LNK_SLIMBUS_BRIDGE_FILE_WRITE_ERROR			(-6)
#define LNK_SLIMBUS_BRIDGE_FILE_READ_ERROR			(-7)
#define LNK_SLIMBUS_BRIDGE_COMMAND_BUSY				(-8)
#define LNK_SLIMBUS_BRIDGE_INVALID_VALUE			(-9)
#define LNK_SLIMBUS_BRIDGE_NO_LIBRARY_LOADED		(-10)
#define LNK_SLIMBUS_BRIDGE_ERROR_LAST				(-10)
#define	LNK_SLIMBUS_BRIDGE_INVALID_RETURN_PARAMETERS (-11)



// int _stdcall LnKSLIMbusOpen(void);
//
// This function opens the interface to the SLIMbus Bridge
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//


// int _stdcall LnKSLIMbusClose(void);
//
// This function closes the interface to the SLIMbus Bridge
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//


// int _stdcall LnKSLIMbusGetSWVersion(void);
//
// This function requests the version number of the software of the SLIMbus Bridge Software
//
// Input parameters: 
//						- none
//
// Return value: 
//						- version  (in decimal ex. 153 means 1.53) 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusGetDLLVersion(void);
//
// This function requests the version number of this DLL of the SLIMbus Bridge interface
//
// Input parameters: 
//						- none
//
// Return value: 
//						- version  (in decimal ex. 100 means 1.00) 
//						
//


// int _stdcall LnKSLIMbusBridgeLoadProjectFile( char * filename );
//
// This function opens a project file
//
// Input parameters: 
//						- char * filename
//							
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusBridgeRequestScriptLibraryContent( char * FileList);
//
// This function replies with a list of scripts (string format) that can be played
//
// Input parameters: 
//						- char * FileList
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY



// int _stdcall LnKSLIMbusBridgePlayScript( char * filename );
//
// This function executes a specific script of the library
//
// Input parameters: 
//						- char * filename
//							This filename will be executed
//
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusBridgeRequestPortConfiguration( char * portstatus, int * ipr, int * iprmis, int * opr, int * oprmis );
//
// This function replies with a structure describing each data ports
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//						if > 0
//						- A structure describing each data ports
//

// int _stdcall LnKSLIMbusBridgeRequestBridgeConfiguration( void );
//
// This function replies with a structure describing the global status of the Brodge
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//						if > 0
//						- A structure describing the status of the Bridge
//

// int _stdcall LnKSLIMbusBridgeLoadScriptLibrary( char * filename );
//
// This function loads a script library
//
// Input parameters: 
//						- char * filename
//							This filename will be used to load a script library
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusBridgeLoadScript( char * filename );
//
// This function loads a single script 
//
// Input parameters: 
//						- char * filename
//							This filename will be used to load a script 
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusBridgePlayBuffer(void);
//
// This function runs the content of the message transmit buffer
//
//
// Input parameters: 
//						- none
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//

// int _stdcall LnKSLIMbusBridgeRequestModel(char * ModelType, char * FirmwareVersion, char * IPVersion);
//
// This function replies with model type, HW version, Firmware version and IP version
//
// Input parameters: 
//						- char * ModelType
//						- char * FirmwareVersion
//						- char * IPVersion);
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY

//


// int _stdcall LnKSLIMbusBridgeRequestBusStatus( int * ClockGear, int * RootFrequency, int * SubFrameMode, int * Status );
//
// This function sets the parameters of the real SLIMBUS signals of the hardware capture unit
//
// Input parameters: 
//						- int * ClockGear
//
//						- int * RootFrequency
//
//						- int * SubFrameMode
//
//						- int * Status
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY
//


//  int _stdcall BridgePlayMessage(int  MsgType, int MsgCode, char * SrcAddr, char * DstAddr, char * Params )
//
// This function directly play a given message
//
// Input parameters: 
//						-  int  MsgType
//
//						-  int  MsgCode
//
//						-  int  SrcAddr
//
//						-  int  DstAddr
//
//						-  char * Params
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgePlayScriptFromLibrary(int  ScriptID  );
//
// This function directly play a given message
//
// Input parameters: 
//						-  int  ScriptID 
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_COMMAND_BUSY



// int _stdcall LnKSLIMbusBridgeFramerControl( int ctrl );
//
// This function opens a project file
//
// Input parameters: 
//						- int ctrl
//							
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY
//

// int _stdcall LnKSLIMbusBridgeManagerControl( int ctrl );
//
// This function opens a project file
//
// Input parameters: 
//						- int ctrl
//							
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusBridgeSnifferControl( int ctrl );
//
// This function opens a project file
//
// Input parameters: 
//						- int ctrl
//							
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY
//


// int _stdcall LnKSLIMbusBridgeReset( void );
//
// This function opens a project file
//
// Input parameters: 
//						- void
//							
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY
//




//  int _stdcall LnKSLIMbusBridgeImportRegister(char * filename,  int  logicaladdress, int slicesize );
//
// This function imports the registers in CSV format
//
// Input parameters: 
//						-  char * filename
//
//						-  int  logicaladdress
//
//						-  int slicesize 
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_FILE_READ_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY

//  int _stdcall LnKSLIMbusBridgeExportRegister(char * filename );
//
// This function exports the registers in CSV format
//
// Input parameters: 
//						-  char * filename
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY



//  int _stdcall LnKSLIMbusBridgeExportLiveView(char * filename, unsigned long startindex  );
//
// This function exports the captured Live View Messages
//
// Input parameters: 
//						-  char * filename
//
//						-  unsigned long startindex 
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY




// int _stdcall LnKSLIMbusGetReply( char * reply, int len );
//
//
// Input parameters: 
//						- char *	reply
//						- int		len
//							
//
// Return value: 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY
//



//  int _stdcall LnKSLIMbusBridgeWriteRegister(int logicaladdress, int regaddress, char * datastring );
//
// This function writes a registers with the content of the datastring
//
// Input parameters: 
//						-  int  logicaladdress
//
//						-  int	regaddress 
//
//						-  char * datastring
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgeReadRegister(int  logicaladdress, int regaddress, int slicesize, char * datastring );
//
// This function reads the registers at regaddress of the size of slicesize
//
// Input parameters: 
//						-  int  logicaladdress
//
//						-  int	regaddress 
//
//						-  int	slicesize 
//
//						-  char * datastring   pointer to a buffer of 512 bytes
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY



//  int _stdcall LnKSLIMbusBridgeSetPollTiming(int  DLLPollTimeMs, int AudioBridgePollTimeMs );
//
// This function reads the registers at regaddress of the size of slicesize
//
// Input parameters: 
//						-  int  DLLPollTimeMs			poll time of the reply from the Bridge used inside the DLL
//
//						-  int	AudioBridgePollTimeMs   poll time in the Bridge used to poll the command from the DLL
//
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)












//  int _stdcall LnKSLIMbusBridgeLiveViewCount(void);
//
// This function returns the number of Live View Messages
//
// Input parameters: 
//						-  void
//
//
// Return value: 
//						if( >=0 ) 
//						- number of LiveView messages 
//
//						if( < 0 ) error status ...
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgeReportFramerConfig( int * FramerBootFrequency, int * FramerBootSM, int * FramerBootCG, int * FramerBootMode, int * ComponentAddress );
//
// This function handles Report Framer config (12P model)
//
// Input parameters: 
//						-  int * FramerBootFrequency pointer to the returned value of Framer Boot Frequency
//						-  int * FramerBootSM pointer to the returned value of Framer Boot Subframe Mode
//						-  int * FramerBootCG pointer to the returned value of Framer Boot Clock Gear
//						-  int * FramerBootMode pointer to the returned value of Framer Boot Mode (Primary or Inactive)
//						-  int * ComponentAddress pointer to the returned value of Component Instance Value (IV)
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgeReportPhyConfig( int * SLIMbusLevel, int * BusHoldEnabled, int * SD1Assign );
//
// This function handles Report PHY config (12P model)
//
// Input parameters: 
//						-  int * SLIMbusLevel pointer to the returned value of SLIMbusLevel in mV (int16)
//						-  int * BusHoldEnabled pointer to the returned value of Bus Hold
//						-  int * SD1Assign pointer to the returned value of DP1_Assign
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgeReportClkConfig( int * ExtClkLevel, int * ExtClkDir, int * ExtClkZin , int * ExtClkSrc , int * ExtClkDiv , int * FramerPllRef, int * AudioPllRef );
//
// This function handles Report CLK config (12P model)
//
// Input parameters: 
//						-  int * ExtClkLevel pointer to the returned value of External clock level (0=1.8V, 1=2.5V, 2=3.3V)
//						-  int * ExtClkDir pointer to the returned value of External clock SMA function (0=input, 1=output)
//						-  int * ExtClkZin pointer to the returned value of External clock input imedance (0=1M, 1=50R)
//						-  int * ExtClkSrc pointer to the returned value of Output clock source (0=Framer, 1=MCLKI1, 2=MCLKO1, 3=MCLK2)
//						-  int * ExtClkDiv pointer to the returned value of Division factor applied on the output clock frequency
//						-  int * FramerPllRef pointer to the returned value of Framer PLL clock reference
//						-  int * AudioPllRef pointer to the returned value of Audio PLL clock reference
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY


    
//  int _stdcall LnKSLIMbusBridgeReportDigAudioConfig( int * SpdifAsrcMode, int * OpticalAsrcMode, int * DsiOutAsrcMode , int * DsiOutAsrcClrRef , int * DsiLevel , int * DsiInFormat, int * DsiInDL , int * DsiInClkMode , int * DsiOutFormat , int * DsiOutDL, int * DsiOutClkMode );
//
// This function handles Report Digital Audio Config (12P model)
//
// Input parameters: 
//						-  int * SpdifAsrcMode pointer to the returned value of Input 1 ASRC (0=disable, 1=Enable)
//						-  int * OpticalAsrcMode pointer to the returned value of Input 2 ASRC (0=disable, 1=Enable)
//						-  int * DsiOutAsrcMode pointer to the returned value of Output 1 ASRC (0=disable, 1=Enable)
//						-  int * DsiOutAsrcClrRef pointer to the returned value of Output 1 ASRC reference clock (0=DSI MCLK, 1=MCLKO1)
//						-  int * DsiLevel pointer to the returned value of DSI signaling level (0=1V8, 1=2V5, 2=3V3)
//						-  int * DsiInFormat pointer to the returned value of DSI input format (0=Left Justified, 1=I2S, 2=Right Justified)
//						-  int * DsiInDL pointer to the returned value of DSI input sample size (0=16 bits, 1=20 bits, 2=24 bits)
//						-  int * DsiInClkMode pointer to the returned value of DSI input clock mode (0=Slave, 1=Master)
//						-  int * DsiOutFormat pointer to the returned value of DSI output format (0=Left Justified, 1=I2S, 2=Right Justified)
//						-  int * DsiOutDL pointer to the returned value of DSI output sample size (0=16 bits, 1=20 bits, 2=24 bits)
//						-  int * DsiOutClkMode pointer to the returned value of DSI output clock mode (0=Slave, 1=Master)
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY


    
//  int _stdcall LnKSLIMbusBridgeReportDataPathConfig( int * Sdin12Sel, int * Sdin34Sel, int * Dsi8ChInEna , int * Sdin56Sel , int * Sdout1Sel , int * Dsi8ChOutEna, int * Sdout2Sel , int * LoopBackMode );
//
// This function handles Report the data path config (12P model)
//
// Input parameters: 
//						-  int * Sdin12Sel pointer to the returned value of Input 1 / P0-3 source selection (0=SPDIF, 1=Optical, 2=DSI, 3=ToneGen)
//						-  int * Sdin34Sel pointer to the returned value of Input 1 / P4-7 source selection (0=P0-3, 1=ToneGen)
//						-  int * Dsi8ChInEna pointer to the returned value of Input 1 8Ch input mode
//						-  int * Sdin56Sel pointer to the returned value of Input 2 / P8-11 source selection (0=SPDIF, 1=Optical, 2=Analogue)
//						-  int * Sdout1Sel pointer to the returned value of Output 1 port selection for the SPDIF/DSI output
//						-  int * Dsi8ChOutEna pointer to the returned value of Output 1 8Ch mode
//						-  int * Sdout2Sel pointer to the returned value of Output 2 port selection for the Optical/analog output
//						-  int * LoopBackMode pointer to the returned value of Loopback mode
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY

   
//  int _stdcall LnKSLIMbusBridgeReportPresenceRate( int * PresenceRate[12] );
//
// This function handles Report the presence rate of all the ports
//
// Input parameters: 
//						-  int * PresenceRate[12]  pointer to the returned 12 value of prsence rates of port 0 -> 11
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgeIPReset(void);
//
// This function generate a faster RESET than the LnKSLIMbusBridgeReset()  function
//
// Input parameters: 
//						-  void
//
//
// Return value: 
//						 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_COMMAND_BUSY

//  int _stdcall LnKSLIMbusBridgeLoadScriptAutomator(char * filename );
//
// This function defines which file to be loaded by the script automator
//
// Input parameters: 
//						-  char * filename   the file to be loaded by the script automator.
//
//
// Return value: 
//						- LNK_SLIMBUS_OK
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_HARDWARE_NOT_CONNECTED
//						- LNK_SLIMBUS_FILE_WRITE_ERROR
//						- LNK_SLIMBUS_ACTION_NOT_ALLOWED ( ex. if the bridge is still recording)
//						- LNK_SLIMBUS_COMMAND_BUSY



//  int _stdcall LnKSLIMbusBridgeUseLiterals( int enable );
//
// This function enables whether files should see their literals replaced at load (0=off, 1=on).
//
// Input parameters: 
//						-  int enable
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_BRIDGE_OK
//						- LNK_SLIMBUS_COMMAND_BUSY



//  int _stdcall LnKSLIMbusBridgeClearLiveView(void);
//
// This function clears the Live View
//
// Input parameters: 
//						-  void
//
//
// Return value: 
//						 
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_BRIDGE_OK
//						- LNK_SLIMBUS_COMMAND_BUSY


//  int _stdcall LnKSLIMbusBridgeExtClockConfig( unsigned long Level, unsigned long SMAFunction, unsigned long Impedance, unsigned long OutputSource, unsigned long DivisionFactor, unsigned long FramerPLLRef, unsigned long AudioPLLRef, unsigned long Frequency );
//
// This function handles External Clock Conifg (12P model)
//
// Input parameters: 
//						-  unsigned long Level, External clock level (0=1.8V, 1=2.5V, 2=3.3V)
//						-  unsigned long SMAFunction, External clock SMA function (0=input, 1=output)
//						-  unsigned long Impedance, External clock input impedance (0=1M, 1=50R)
//						-  unsigned long OutputSource, Output clock source (0=Framer, 1=MCLKI1, 2=MCLKO1, 3=MCLK2, 4=UserDef)
//						-  unsigned long DivisionFactor, Division factor applied on the output clock frequency (max 127)
//						-  unsigned long FramerPLLRef, Framer PLL clock reference
//						-  unsigned long AudioPLLRef, Audio PLL clock reference
//						-  unsigned long Frequency, User Defined frequency (in Hz) - 
//
// Return value: 
//						
//						- LNK_SLIMBUS_BRIDGE_NOT_FOUND
//						- LNK_SLIMBUS_BRIDGE_OK
//						- LNK_SLIMBUS_COMMAND_BUSY



