// TestLnKBridgeLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestLnKBridgeLib.h"
#include "TestLnKBridgeLibDlg.h"
#include "LnKSLIMbusBridge_IF.h"
#include "direct.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define DEBUG_ON	1

char * errortxt[] = 
{
"LNK_OK",
"LNK_BRIDGE_NOT_FOUND",
"LNK_ACTION_NOT_ALLOWED",
"LNK_FILE_WRITE_ERROR",
"LNK_FILE_READ_ERROR",
"LNK_HARDWARE_NOT_CONNECTED",
"LNK_COMMAND_BUSY",
"LNK_INVALID_VALUE",
"LNK_NO_BUS_ACTIVITY_SEEN",
"LNK_ERROR_LAST"
};




/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestLnKBridgeLibDlg dialog

CTestLnKBridgeLibDlg::CTestLnKBridgeLibDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestLnKBridgeLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestLnKBridgeLibDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestLnKBridgeLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestLnKBridgeLibDlg)
	DDX_Control(pDX, IDC_CHECK_USE_LITERALS, m_UseLiterals);
	DDX_Control(pDX, IDC_EDIT_AUTOMATOR_FILENAME, m_AutomatorFilename);
	DDX_Control(pDX, IDC_EDIT_DLL_POLL_TIME, m_DLLPollTime);
	DDX_Control(pDX, IDC_EDIT_BRIDGE_POLL_TIME, m_BridgePollTime);
	DDX_Control(pDX, IDC_EDIT_WRITE_REG_LA, m_WriteRegLA);
	DDX_Control(pDX, IDC_EDIT_WRITE_REG_ADDRESS, m_WriteRegAddress);
	DDX_Control(pDX, IDC_EDIT_WRITE_DATA, m_WriteRegData);
	DDX_Control(pDX, IDC_EDIT_READ_SLICE_SIZE, m_ReadRegSliceSize);
	DDX_Control(pDX, IDC_EDIT_READ_REG_LA, m_ReadRegLA);
	DDX_Control(pDX, IDC_EDIT_READ_REG_ADDRESS, m_ReadRegAddress);
	DDX_Control(pDX, IDC_EDIT_READ_DATA, m_ReadData);
	DDX_Control(pDX, IDC_EDIT_LV_START, m_LVStart);
	DDX_Control(pDX, IDC_EDIT_EXPORT_LV_FN, m_ExportLiveViewFilename);
	DDX_Control(pDX, IDC_EDIT_EXPORT_REG_FN, m_ExportRegFilename);
	DDX_Control(pDX, IDC_EDIT_IMPORT_REG_SS, m_ImportRegSS);
	DDX_Control(pDX, IDC_EDIT_IMPORT_REG_LA, m_ImportRegLA);
	DDX_Control(pDX, IDC_EDIT_IMPORT_REG_FN, m_ImportRegFilename);
	DDX_Control(pDX, IDC_EDIT_BRIDGE_STATUS, m_BridgeStatus);
	DDX_Control(pDX, IDC_EDITMSG_CODE, m_MsgCode);
	DDX_Control(pDX, IDC_EDIT_SRC_ADDRESS, m_MsgSrcAddr);
	DDX_Control(pDX, IDC_EDIT_DST_ADDRESS, m_MsgDstAddr);
	DDX_Control(pDX, IDC_EDIT_MSG_PAYLOAD, m_MsgPayload);
	DDX_Control(pDX, IDC_EDIT_MSG_TYPE, m_MsgType);
	DDX_Control(pDX, IDC_CHECK_SNIFFER_CTRL, m_SnifferEn);
	DDX_Control(pDX, IDC_CHECK_MANAGER_CTRL, m_ManagerEn);
	DDX_Control(pDX, IDC_CHECK_FRAMER_CTRL, m_FramerEn);
	DDX_Control(pDX, IDC_EDIT_PORT_STATUS, m_PortStatus);
	DDX_Control(pDX, IDC_EDITBUS_STATUS, m_BusStatus);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_ID, m_ScriptID);
	DDX_Control(pDX, IDC_EDITLOAD_SCRIPT, m_LoadScriptFile);
	DDX_Control(pDX, IDC_EDITLOAD_SCRIPT_LIB, m_LoadScriptLibFile);
	DDX_Control(pDX, IDC_EDIT_PLAY_SCRIPT, m_PlayScript);
	DDX_Control(pDX, IDC_EDIT_FILENAME1, m_FileLoad);
	DDX_Control(pDX, IDC_EDIT_LOG, m_Log);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_EDIT_CONNECT_IDX, m_ConnectIdx);
	DDX_Control(pDX, IDC_EDIT_LIST, m_bridgelist);
}

BEGIN_MESSAGE_MAP(CTestLnKBridgeLibDlg, CDialog)
	//{{AFX_MSG_MAP(CTestLnKBridgeLibDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DLL_VER, OnButtonDllVer)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_SW_VER, OnButtonSwVer)
	ON_BN_CLICKED(IDC_BUTTON_BRIDGE_VER, OnButtonBridgeVer)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_PROJECT_FILE, OnButtonLoadProjectFile)
	ON_BN_CLICKED(IDC_BUTTON_REQ_SCRIPT_LIB_CONTENT, OnButtonReqScriptLibContent)
	ON_BN_CLICKED(IDC_BUTTONPLAY_SCRIPT, OnButtonplayScript)
	ON_BN_CLICKED(IDC_BUTTONLOAD_SCRIPT_LIB, OnButtonloadScriptLib)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_SCRIPT, OnButtonLoadScript)
	ON_BN_CLICKED(IDC_BUTTONPLAY_BUFFER, OnButtonplayBuffer)
	ON_BN_CLICKED(IDC_BUTTON_REQ_PORT_CONFIG, OnButtonReqPortConfig)
	ON_BN_CLICKED(IDC_BUTTON_REQ_BUS_STAT, OnButtonReqBusStat)
	ON_BN_CLICKED(IDC_BUTTONPLAY_SCRIPT_ID, OnButtonplayScriptId)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_FILE1, OnButtonFile1)
	ON_BN_CLICKED(IDC_BUTTON_FILE2, OnButtonFile2)
	ON_BN_CLICKED(IDC_BUTTON_FILE3, OnButtonFile3)
	ON_BN_CLICKED(IDC_BUTTON_FILE4, OnButtonFile4)
	ON_BN_CLICKED(IDC_CHECK_FRAMER_CTRL, OnCheckFramerCtrl)
	ON_BN_CLICKED(IDC_CHECK_MANAGER_CTRL, OnCheckManagerCtrl)
	ON_BN_CLICKED(IDC_CHECK_SNIFFER_CTRL, OnCheckSnifferCtrl)
	ON_BN_CLICKED(IDC_BUTTONSEND_MSG, OnButtonsendMsg)
	ON_BN_CLICKED(IDC_BUTTON_REQ_BRIDGE_CONFIG, OnButtonReqBridgeConfig)
	ON_BN_CLICKED(IDC_BUTTONPLAY_SCRIPT2, OnButtonImportRegister)
	ON_BN_CLICKED(IDC_BUTTONEXPORT_REGISTER, OnButtonexportRegister)
	ON_BN_CLICKED(IDC_BUTTON_EXPORT_LV, OnButtonExportLv)
	ON_BN_CLICKED(IDC_BUTTON_FILE5, OnButtonFile5)
	ON_BN_CLICKED(IDC_BUTTON_FILE6, OnButtonFile6)
	ON_BN_CLICKED(IDC_BUTTON_FILE7, OnButtonFile7)
	ON_BN_CLICKED(IDC_BUTTON_LV_COUNT, OnButtonLvCount)
	ON_BN_CLICKED(IDC_BUTTON_WRITE_REGISTER, OnButtonWriteRegister)
	ON_BN_CLICKED(IDC_BUTTON_READ_REGISTER, OnButtonReadRegister)
	ON_BN_CLICKED(IDC_BUTTON_SET_POLL_TIMING, OnButtonSetPollTiming)
	ON_BN_CLICKED(IDC_BUT_REPORT_FRAMER_CONFIG, OnButReportFramerConfig)
	ON_BN_CLICKED(IDC_BUT_REPORT_PHY_CONFIG, OnButReportPhyConfig)
	ON_BN_CLICKED(IDC_BUT_REPORT_CLOCK_CONFIG, OnButReportClockConfig)
	ON_BN_CLICKED(IDC_BUT_REPORT_DIG_AUDIO_CONFIG, OnButReportDigAudioConfig)
	ON_BN_CLICKED(IDC_BUT_REPORT_DATA_PATH_CONFIG, OnButReportDataPathConfig)
	ON_BN_CLICKED(IDC_BUT_REPORT_PRESENCE_RATE, OnButReportPresenceRate)
	ON_BN_CLICKED(IDC_BUT_IP_RESET, OnButIpReset)
	ON_BN_CLICKED(IDC_BUTTON_LOAD_AUTOMATOR_FILE, OnButtonLoadAutomatorFile)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_LIVE_VIEW, OnButtonClearLiveView)
	ON_BN_CLICKED(IDC_BUTTON_AUTOMATOR_FILE, OnButtonAutomatorFile)
	ON_BN_CLICKED(IDC_CHECK_USE_LITERALS, OnCheckUseLiterals)
	//}}AFX_MSG_MAP

	ON_BN_CLICKED(IDC_BUTTON_OPEN2, &CTestLnKBridgeLibDlg::OnBnClickedButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_REFRESHLIST, &CTestLnKBridgeLibDlg::OnBnClickedButtonRefreshlist)
	ON_BN_CLICKED(IDC_BUTTON_GETLIST, &CTestLnKBridgeLibDlg::OnBnClickedButtonGetlist)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CTestLnKBridgeLibDlg::OnBnClickedButtonConnect)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestLnKBridgeLibDlg message handlers

BOOL CTestLnKBridgeLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}


	// init reply buffer
	m_replybuf[0] = 0;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestLnKBridgeLibDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestLnKBridgeLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestLnKBridgeLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CTestLnKBridgeLibDlg::OnButtonOpen() 
{
	int status;
	char buf[255];

	m_Log.SetWindowText("Opening ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusOpen();

	if( status >= 0 )
	{

		sprintf( buf,"Open = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Open - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Open - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnButtonClose() 
{
	int status;
	char buf[255];

	m_Log.SetWindowText("Closing ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusClose();

	if( status >= 0 )
	{

		sprintf( buf,"Close = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Close - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Close - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestLnKBridgeLibDlg::OnButtonDllVer() 
{
	int status;
	char buf[255];

	status = LnKSLIMbusGetDLLVersion();

	if( status >= 0 )
	{

		sprintf( buf,"DLL software version = %d.%02d", status/0x100, status%0x100 );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"GetDLLVersion - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetDLLVersion - Error code %d [Unknown error]", status );
		}
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}


void CTestLnKBridgeLibDlg::OnButtonSwVer() 
{
	int status;
	char buf[255];

	m_Log.SetWindowText("Getting Bridge SW version ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusGetSWVersion();

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );
		status = atoi( m_replybuf );

		sprintf( buf,"LnK Bridge software version = %02x.%02x.%02x", (status&0xff0000)>>16, (status&0xff00)>>8, status &0xff);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"GetSWVersion - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"GetSWVersion - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonBridgeVer() 
{
	int status = 0;
	char buf[255];
	char ModelType[40];
	char FirmwareVersion[40];
	char IPVersion[40];

	m_Log.SetWindowText("Getting Bridge model info ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeRequestModel(ModelType, FirmwareVersion, IPVersion);

	if( status >= 0 )
	{
		sprintf( buf,"LnK Bridge Model Type = %s FirmwareVersion %s IPVersion %s"
			, ModelType
			, FirmwareVersion
			, IPVersion
			);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Get Bridge Model - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Get Bridge Model - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}



void CTestLnKBridgeLibDlg::OnButtonLoadProjectFile() 
{

	CString filename;
	int status;
	char buf[255];

	m_FileLoad.GetWindowText( filename );

	sprintf( buf, "Loading Project File [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusBridgeLoadProjectFile( buf );

	if( status >= 0 )
	{
		sprintf( buf,"Fileload %s = %d ", filename, status  );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Fileload - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Fileload - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestLnKBridgeLibDlg::OnButtonReqScriptLibContent() 
{

	int status;
	char buf[1024];


	sprintf( buf, "Request Script Library Content .....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();


	status = LnKSLIMbusBridgeRequestScriptLibraryContent( buf );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Script Library Content [%s] (reply: %s)", buf, m_replybuf );

	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Request Script Library Content - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Request Script Library Content - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}




void CTestLnKBridgeLibDlg::OnButtonplayScript() 
{

	CString filename;
	int status;
	char buf[255];

	m_PlayScript.GetWindowText( filename );

	sprintf( buf, "Play Script File [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusBridgePlayScript( buf );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"PlayScript %s = %d Reply [%s]", filename, status , m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"PlayScript - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"PlayScript - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnButtonloadScriptLib() 
{
	CString filename;
	int status;
	char buf[255];

	m_LoadScriptLibFile.GetWindowText( filename );

	sprintf( buf, "Load Script File [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusBridgeLoadScriptLibrary( buf );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Load Script %s = %d Reply [%s]", filename, status , m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Load Script Lib - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Load Script Lib - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonLoadScript() 
{
	CString filename;
	int status;
	char buf[255];

	m_LoadScriptFile.GetWindowText( filename );

	sprintf( buf, "Load Script File [%s] .....", filename);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	sprintf( buf, "%s", filename);

	status = LnKSLIMbusBridgeLoadScript( buf );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Load Script %s = %d Reply: [%s]", filename, status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Load Script - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Load Script - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonplayBuffer() 
{
	int status = 0;
	char buf[255];

	m_Log.SetWindowText("Play Buffer ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgePlayBuffer();

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Play Buffer ok Reply: [%s]", m_replybuf);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Play Buffer - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Play Buffer - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}






void CTestLnKBridgeLibDlg::OnButtonReqPortConfig() 
{
	int		status = 0;
	char	buf[255];
	char	portstatus[10];
	int		ipr = 0;
	int		iprmis = 0;
	int		opr = 0;
	int		oprmis = 0;

	m_Log.SetWindowText("RequestPortConfiguration ....");
	m_Log.UpdateWindow();

	portstatus[0] = 0;

	status = LnKSLIMbusBridgeRequestPortConfiguration( portstatus, &ipr, &iprmis, &opr, &oprmis );

	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"RequestPortConfiguration - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"RequestPortConfiguration - Error code %d [Unknown error]", status );
		}
	}
	else
	{
//		m_replybuf[0] = 0;
//		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"RequestPortConfiguration ok ", m_replybuf);

		sprintf( buf, "%c %c %c %c %c %c %c %c \r\nInput Presence Rate = %d \r\nInput Presence Rate mismatch =  %d \r\nOutput Presence Rate = %d \r\nOutput Presence Rate mismatch = %d"
			, portstatus[0]
			, portstatus[1]
			, portstatus[2]
			, portstatus[3]
			, portstatus[4]
			, portstatus[5]
			, portstatus[6]
			, portstatus[7]
			, ipr
			, iprmis
			, opr
			, oprmis );
		m_PortStatus.SetWindowText(buf);
		m_PortStatus.UpdateWindow();
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnButtonReqBusStat() 
{
	int status = 0;
	char buf[255];
	int ClockGear = 0;
	int RootFrequency = 0;
	int SubFrameMode = 0;
	int Status = 0;


	m_Log.SetWindowText("RequestBusStatus ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeRequestBusStatus(&ClockGear, &RootFrequency, &SubFrameMode, &Status );


	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"RequestBusStatus - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"RequestBusStatus - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "RF %d, CG %d, IP Frozen %d, IP Paused %d"
			, RootFrequency
			, ClockGear
			, SubFrameMode
			, Status
			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonReqBridgeConfig() 
{
	int status = 0;
	char buf[255];

	m_Log.SetWindowText("RequestBridgeConfiguration ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeRequestBridgeConfiguration();

	if( status >= 0 )
	{
		m_replybuf[0] = 0;
		LnKSLIMbusGetReply( m_replybuf, 511 );
		sprintf( buf,"RequestBridgeConfiguration ok Reply: [%s]", m_replybuf);
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"RequestBridgeConfiguration - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"RequestBridgeConfiguration - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
	sprintf( buf, "%s", m_replybuf );
	m_BridgeStatus.SetWindowText(buf);
	m_BridgeStatus.UpdateWindow();
}



void CTestLnKBridgeLibDlg::OnButtonplayScriptId() 
{
	CString IDstring;
	int status;
	char buf[255];
	int	ID = 0;

	m_ScriptID.GetWindowText( IDstring );
	ID = atoi(IDstring);

	sprintf( buf, "Load Script File [%d] .....", ID);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgePlayScriptFromLibrary( ID );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Play Script ID %d = %d Reply [%s]", ID, status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Play Script - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Play Script - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonframerCtrl() 
{
}

void CTestLnKBridgeLibDlg::OnButtonmanagerCtrl() 
{
}

void CTestLnKBridgeLibDlg::OnButtonsnifferCtrl() 
{
}


void CTestLnKBridgeLibDlg::OnButtonReset() 
{
	int status;
	char buf[255];


	sprintf( buf, "Reset Bridge .....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReset();

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"BridgeReset = %d Reply [%s]", status , m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"BridgeReset - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"BridgeReset - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonFile1() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_FileLoad.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_FileLoad.UpdateWindow();
	}
}

void CTestLnKBridgeLibDlg::OnButtonFile2() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_LoadScriptLibFile.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_LoadScriptLibFile.UpdateWindow();
	}
}

void CTestLnKBridgeLibDlg::OnButtonFile3() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_LoadScriptFile.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_LoadScriptFile.UpdateWindow();
	}
}

void CTestLnKBridgeLibDlg::OnButtonFile4() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_PlayScript.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_PlayScript.UpdateWindow();
	}
}

void CTestLnKBridgeLibDlg::OnCheckFramerCtrl() 
{
	int status;
	char buf[255];

	if (m_FramerEn.GetCheck() )
	{
		status = LnKSLIMbusBridgeFramerControl( 1 );
	}
	else
	{
		status = LnKSLIMbusBridgeFramerControl( 0 );
	}

	if( status >= 0 )
	{

		sprintf( buf,"Framer Ctrl  %d = %d", m_FramerEn.GetCheck(), status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Framer Ctrl - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Framer Ctrl - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnCheckManagerCtrl() 
{
	int status;
	char buf[255];

	if (m_ManagerEn.GetCheck() )
	{
		status = LnKSLIMbusBridgeManagerControl( 1 );
	}
	else
	{
		status = LnKSLIMbusBridgeManagerControl( 0 );
	}

	if( status >= 0 )
	{

		sprintf( buf,"Manager Ctrl  %d = %d", m_ManagerEn.GetCheck(), status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Manager Ctrl - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Manager Ctrl - Error code %d [Unknown error]", status );
		}
	}



	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnCheckSnifferCtrl() 
{
	int status;
	char buf[255];

	if (m_SnifferEn.GetCheck() )
	{
		status = LnKSLIMbusBridgeSnifferControl( 1 );
	}
	else
	{
		status = LnKSLIMbusBridgeSnifferControl( 0 );
	}

	if( status >= 0 )
	{

		sprintf( buf,"Sniffer Ctrl  %d = %d", m_SnifferEn.GetCheck(), status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Sniffer Ctrl - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Sniffer Ctrl - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonsendMsg() 
{
	CString ValString;
	int status;
	char buf[255];
	int	MsgType = 0;
	int	MsgCode = 0;
	char SrcAddr[7];
	char DstAddr[7];
	char Params[255];



	SrcAddr[0]=0;
	DstAddr[0]=0;
	Params[0]=0;

	m_MsgType.GetWindowText( ValString );
	MsgType = atoi(ValString);

	m_MsgCode.GetWindowText( ValString );
	MsgCode = atoi(ValString);

	m_MsgSrcAddr.GetWindowText( ValString );
	sprintf(SrcAddr, "%6.6s",ValString);

	m_MsgDstAddr.GetWindowText( ValString );
	sprintf(DstAddr, "%6.6s",ValString);

	m_MsgPayload.GetWindowText( ValString );
	sprintf(Params, "%s",ValString);

	sprintf( buf, "Send User Message .....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgePlayMessage(MsgType, MsgCode, SrcAddr, DstAddr, Params );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Play User Msg = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Play Script - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Play Script - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnButtonImportRegister() 
{
	CString ValString;
	int status;
	char buf[255];

	char fn[255];
	char la[255];
	char ss[255];


	m_ImportRegFilename.GetWindowText( ValString );
	sprintf(fn, "%s",ValString);

	m_ImportRegLA.GetWindowText( ValString );
	sprintf(la, "%s",ValString);

	m_ImportRegSS.GetWindowText( ValString );
	sprintf(ss, "%s",ValString);


	sprintf( buf, "Send User Message (ImportRegister).....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeImportRegister(fn, atoi(la), atoi(ss));


	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Import Register status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Import Register - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Import Register - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();


}

void CTestLnKBridgeLibDlg::OnButtonexportRegister() 
{
	CString ValString;
	int status;
	char buf[255];

	char fn[255];


	m_ExportRegFilename.GetWindowText( ValString );
	sprintf(fn, "%s",ValString);

	sprintf( buf, "Send User Message (ExportRegister).....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeExportRegister(fn);

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Export Register status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Export Register - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Export Register - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonExportLv() 
{
	CString ValString;
	int status;
	char buf[255];
	int count = 0;	
	char fn[255];


	m_ExportLiveViewFilename.GetWindowText( ValString );
	sprintf(fn, "%s",ValString);

	m_LVStart.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	count = atoi( buf );

	sprintf( buf, "Send User Message (ExportLiveView).....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeExportLiveView(fn, count);

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Export LiveView status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Export LiveView - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Export LiveView - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}

void CTestLnKBridgeLibDlg::OnButtonFile5() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_ExportLiveViewFilename.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_ExportLiveViewFilename.UpdateWindow();
	}
	
}

void CTestLnKBridgeLibDlg::OnButtonFile6() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_ImportRegFilename.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_ImportRegFilename.UpdateWindow();
	}
	
}

void CTestLnKBridgeLibDlg::OnButtonFile7() 
{
	CFileDialog fd(false, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_ExportRegFilename.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_ExportRegFilename.UpdateWindow();
	}
	
}

void CTestLnKBridgeLibDlg::OnButtonLvCount() 
{
	CString ValString;
	int status;
	char buf[255];


	sprintf( buf, "Send User Message (LiveViewCount).....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeLiveViewCount();

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Counter = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Counter Request - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Counter Request - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnButtonWriteRegister() 
{
	CString ValString;
	int		status;
	char	buf[255];
	int		LA;
	int		RegAddress;
	char	WriteData[512];




	m_WriteRegLA.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	LA = atoi( buf);

	m_WriteRegAddress.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	RegAddress = atoi( buf);

	m_WriteRegData.GetWindowText( ValString );
	sprintf(WriteData, "%s",ValString);



	sprintf( buf, "Send User Message (Write Register).....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeWriteRegister(LA, RegAddress, WriteData );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Write Register status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Write Register - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Write Register - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
}

void CTestLnKBridgeLibDlg::OnButtonReadRegister() 
{
	CString ValString;
	int		status;
	char	buf[255];
	int		LA;
	int		RegAddress;
	int		SliceSize;
	char	ReadData[512];


	m_ReadRegLA.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	LA = atoi( buf);

	m_ReadRegAddress.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	RegAddress = atoi( buf);

	m_ReadRegSliceSize.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	SliceSize = atoi( buf);


	sprintf( buf, "Send User Message (Read Register).....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReadRegister(LA, RegAddress, SliceSize, ReadData );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Read Register status = %d Reply [%s]", status, m_replybuf );
		m_ReadData.SetWindowText(m_replybuf);
		m_ReadData.UpdateWindow();
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Read Register - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Read Register - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	
}

void CTestLnKBridgeLibDlg::OnButtonSetPollTiming() 
{
	CString ValString;
	int		status;
	char	buf[255];
	int		DLLPollTimeMs;
	int		AudioBridgePollTimeMs;



	m_DLLPollTime.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	DLLPollTimeMs = atoi( buf);

	m_BridgePollTime.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	AudioBridgePollTimeMs = atoi( buf);


	sprintf( buf, "SetPollTiming.....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeSetPollTiming(DLLPollTimeMs, AudioBridgePollTimeMs);

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"SetPollTiming status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"SetPollTiming - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"SetPollTiming - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
	
}





void CTestLnKBridgeLibDlg::OnButReportFramerConfig() 
{
	int		status = 0;
	char	buf[255];
	int		FramerBootFrequency = 0;
	int		FramerBootSM = 0;
	int		FramerBootCG = 0;
	int		FramerBootMode = 0;
	int		ComponentAddress = 0;

	m_Log.SetWindowText("ReportFramerConfig ....");
	m_Log.UpdateWindow();


	status = LnKSLIMbusBridgeReportFramerConfig( &FramerBootFrequency, &FramerBootSM, &FramerBootCG, &FramerBootMode, &ComponentAddress );
	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ReportFramerConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ReportFramerConfig - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "FramerBootFrequency %d, FramerBootSM %d, FramerBootCG %d, FramerBootMode %d ComponentAddress %d"
			, FramerBootFrequency
			, FramerBootSM
			, FramerBootCG
			, FramerBootMode
			, ComponentAddress
			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
}

void CTestLnKBridgeLibDlg::OnButReportPhyConfig() 
{
	int		status = 0;
	char	buf[255];
	int		SLIMbusLevel = 0;
	int		BusHoldEnabled = 0;
	int		SD1Assign = 0;


	m_Log.SetWindowText("ReportPhyConfig ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReportPhyConfig( &SLIMbusLevel, &BusHoldEnabled, &SD1Assign );
	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ReportPhyConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ReportPhyConfig - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "SLIMbusLevel %d, BusHoldEnabled %d, SD1Assign %d"
			, SLIMbusLevel
			, BusHoldEnabled
			, SD1Assign
			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
}


void CTestLnKBridgeLibDlg::OnButReportClockConfig() 
{
	int		status = 0;
	char	buf[255];
	int		ExtClkLevel = 0;
	int		ExtClkDir = 0;
	int		ExtClkZin = 0;
	int		ExtClkSrc = 0;
	int		ExtClkDiv = 0;
	int		FramerPllRef = 0;
	int		AudioPllRef = 0;



	m_Log.SetWindowText("ReportClockConfig ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReportClkConfig( &ExtClkLevel, &ExtClkDir, &ExtClkZin , &ExtClkSrc , &ExtClkDiv , &FramerPllRef, &AudioPllRef );
	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ReportClockConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ReportClockConfig - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "ExtClkLevel %d, ExtClkDir %d, ExtClkZin %d ExtClkSrc %d ExtClkDiv %d FramerPllRef %d AudioPllRef %d"
			, ExtClkLevel
			, ExtClkDir
			, ExtClkZin
			, ExtClkSrc
			, ExtClkDiv
			, FramerPllRef
			, AudioPllRef
			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
}


void CTestLnKBridgeLibDlg::OnButReportDigAudioConfig() 
{
	int		status = 0;
	char	buf[255];
	int		SpdifAsrcMode = 0;
	int		OpticalAsrcMode = 0;
	int		DsiOutAsrcMode = 0;
	int		DsiOutAsrcClrRef = 0;
	int		DsiLevel = 0;
	int		DsiInFormat = 0;
	int		DsiInDL = 0;
	int		DsiInClkMode = 0;
	int		DsiOutFormat = 0;
	int		DsiOutDL = 0;
	int		DsiOutClkMode = 0;




	m_Log.SetWindowText("ReportDigAudioConfig ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReportDigAudioConfig( &SpdifAsrcMode, &OpticalAsrcMode, &DsiOutAsrcMode , &DsiOutAsrcClrRef , &DsiLevel , &DsiInFormat, &DsiInDL , &DsiInClkMode , &DsiOutFormat , &DsiOutDL, &DsiOutClkMode );
	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ReportDigAudioConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ReportDigAudioConfig - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "SpdifAsrcMode %d, OpticalAsrcMode %d, DsiOutAsrcMode %d DsiOutAsrcClrRef %d DsiLevel %d DsiInFormat %d DsiInDL %d DsiInClkMode %d DsiOutFormat %d DsiOutDL %d DsiOutClkMode %d"
			, SpdifAsrcMode
			, OpticalAsrcMode
			, DsiOutAsrcMode
			, DsiOutAsrcClrRef
			, DsiLevel
			, DsiInFormat
			, DsiInDL
			, DsiInClkMode
			, DsiOutFormat
			, DsiOutDL
			, DsiOutClkMode

			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
	
}

void CTestLnKBridgeLibDlg::OnButReportDataPathConfig() 
{
	int		status = 0;
	char	buf[255];
	int		Sdin12Sel = 0;
	int		Sdin34Sel = 0;
	int		Dsi8ChInEna = 0;
	int		Sdin56Sel = 0;
	int		Sdout1Sel = 0;
	int		Dsi8ChOutEna = 0;
	int		Sdout2Sel = 0;
	int		LoopBackMode = 0;


	m_Log.SetWindowText("ReportDataPathConfig ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReportDataPathConfig( &Sdin12Sel, &Sdin34Sel, &Dsi8ChInEna , &Sdin56Sel , &Sdout1Sel , &Dsi8ChOutEna, &Sdout2Sel , &LoopBackMode );
	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ReportDataPathConfig - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ReportDataPathConfig - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "Sdin12Sel %d, Sdin34Sel %d, Dsi8ChInEna %d Sdin56Sel %d Sdout1Sel %d Dsi8ChOutEna %d Sdout2Sel %d LoopBackMode %d"
			, Sdin12Sel
			, Sdin34Sel
			, Dsi8ChInEna
			, Sdin56Sel
			, Sdout1Sel
			, Dsi8ChOutEna
			, Sdout2Sel
			, LoopBackMode
			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
	
	
}

void CTestLnKBridgeLibDlg::OnButReportPresenceRate() 
{
	int		status = 0;
	char	buf[255];
	int		PresenceRate[12];
	int		* pPresenceRate[12];
	int		a;


	for( a = 0; a < 12; a++ )
	{ 
		PresenceRate[a] = 0;
		pPresenceRate[a] = &PresenceRate[a];
	}

	m_Log.SetWindowText("ReportPresenceRate ....");
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeReportPresenceRate( &pPresenceRate[0] );
	if( status < 0 )
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ReportPresenceRate - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ReportPresenceRate - Error code %d [Unknown error]", status );
		}
	}
	else
	{
		sprintf( buf, "PresenceRate 0: %d,  1: %d,  2: %d,  3: %d,  4: %d,  5: %d,  6: %d,  7: %d,  8: %d,  9: %d,  10: %d, 11: %d"
			, PresenceRate[0]
			, PresenceRate[1]
			, PresenceRate[2]
			, PresenceRate[3]
			, PresenceRate[4]
			, PresenceRate[5]
			, PresenceRate[6]
			, PresenceRate[7]
			, PresenceRate[8]
			, PresenceRate[9]
			, PresenceRate[10]
			, PresenceRate[11]
			);
		m_BusStatus.SetWindowText(buf);
		m_BusStatus.UpdateWindow();
	}
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
	
	
	
}

void CTestLnKBridgeLibDlg::OnButIpReset() 
{
	int status;
	char buf[255];


	sprintf( buf, "IP Reset Bridge .....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeIPReset();

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"Bridge IP Reset = %d Reply [%s]", status , m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Bridge IP Reset - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Bridge IP Reset - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	
}

void CTestLnKBridgeLibDlg::OnButtonLoadAutomatorFile() 
{

	CString ValString;
	int status;
	char buf[255];
	char fn[255];


	m_AutomatorFilename.GetWindowText( ValString );
	sprintf(fn, "%s",ValString);

	sprintf( buf, "LoadScript Automator filename....");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeLoadScriptAutomator(fn);

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"LoadScript Automator filename status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"LoadScript Automator filename - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"LoadScript Automator filename - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();	
}


void CTestLnKBridgeLibDlg::OnButtonAutomatorFile() 
{
	CFileDialog fd(true, "*.*", NULL, 0 );


	if( fd.DoModal() == IDOK )
	{
		m_AutomatorFilename.SetWindowText(  fd.GetPathName() + fd.GetFileName() );
		m_AutomatorFilename.UpdateWindow();
	}
}




void CTestLnKBridgeLibDlg::OnButtonClearLiveView() 
{
	int status;
	char buf[255];


	status = LnKSLIMbusBridgeClearLiveView();

	if( status >= 0 )
	{

		sprintf( buf,"ClearLiveView  = %d", status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ClearLiveView - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ClearLiveView - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
	
}



void CTestLnKBridgeLibDlg::OnCheckUseLiterals() 
{
	int status;
	char buf[255];

	if (m_UseLiterals.GetCheck() )
	{
		status = LnKSLIMbusBridgeUseLiterals( 1 );
	}
	else
	{
		status = LnKSLIMbusBridgeUseLiterals( 0 );
	}

	if( status >= 0 )
	{

		sprintf( buf,"Use Literals  %d = %d", m_UseLiterals.GetCheck(), status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"Use Literals - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"Use Literals - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
	
	
}


void CTestLnKBridgeLibDlg::OnBnClickedButtonDisconnect()
{
	// Disconnect the Bridge - Afbryd broen - Koppla bort broen
	int status;
	char buf[255];

	status = LnKSLIMbusBridgeDisconnectHardware();

	if( status >= 0 )
	{
		sprintf( buf,"DisconnectHardware = %d", m_ManagerEn.GetCheck(), status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"DisconnectHardware - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"DisconnectHardware - Error code %d [Unknown error]", status );
		}
	}



	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestLnKBridgeLibDlg::OnBnClickedButtonRefreshlist()
{
	int status;
	char buf[255];


	status = LnKSLIMbusBridgeRefreshHardwareList( );

	if( status >= 0 )
	{
		sprintf( buf,"RefreshHardwareList = %d",  status );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"RefreshHardwareList - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"RefreshHardwareList - Error code %d [Unknown error]", status );
		}
	}



	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestLnKBridgeLibDlg::OnBnClickedButtonGetlist()
{
	CString ValString;
	int status;
	char buf[512];
	char list[512];


	sprintf( buf, "Send - Getlist ");
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeRequestHardwareList(list);

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		m_bridgelist.SetWindowText(list);
		m_bridgelist.UpdateWindow();

		sprintf( buf,"RequestHardwareList Stat = %d Reply [%s] list [%s]", status, m_replybuf, list );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"RequestHardwareList - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"RequestHardwareList - Error code %d [Unknown error]", status );
		}
	}


	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}


void CTestLnKBridgeLibDlg::OnBnClickedButtonConnect()
{
	CString ValString;
	int status;
	char buf[255];
	unsigned long idx = 0;	
	char fn[255];


	m_ConnectIdx.GetWindowText( ValString );
	sprintf(buf, "%s",ValString);
	idx = atoi( buf );

	sprintf( buf, "Send ConnectHardware  idx = %d.", idx);
	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();

	status = LnKSLIMbusBridgeConnectHardware( idx );

	if( status >= 0 )
	{
		LnKSLIMbusGetReply( m_replybuf, 511 );

		sprintf( buf,"ConnectHardware status = %d Reply [%s]", status, m_replybuf );
	}
	else
	{
		if (( status < 0) && (status > LNK_SLIMBUS_BRIDGE_ERROR_LAST))
		{
			sprintf( buf,"ConnectHardware - Error code %d [%s]", status, errortxt[status * -1] );
		}
		else
		{
			sprintf( buf,"ConnectHardware - Error code %d [Unknown error]", status );
		}
	}

	m_Log.SetWindowText(buf);
	m_Log.UpdateWindow();
}
